# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import bs4 as BeautifulSoup


def update_package():

    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    html_source = wgets("https://pidgin.im/install",proxies=proxies).splitlines()
    for line in html_source:
        if "-offline.exe" in line:
            version = line.split('-')[-2]
            latest_bin = f'pidgin-{version}-offline.exe'
            url_dl = f'https://sourceforge.net/projects/pidgin/files/Pidgin/{version}/pidgin-{version}-offline.exe'

    # Getting latest version information from official sources

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies, connect_timeout=30)

        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin)
        if version != version_from_file and version_from_file != "":
            print("Changing version to the version number of the binary (from: %s to: %s)" % (version, version_from_file))
            os.rename(latest_bin, latest_bin.replace(version, version_from_file))
            version = version_from_file
    else:
        print("Already up to date, skipped")

    # Changing version of the package
    if Version(version) != control.get_software_version():
        print("Software updated to version: %s" % Version(version))
        result = True
    control.version = "%s-%s" % (version, control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return True
